Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 1 | #!/bin/bash -e |
| 2 | |
| 3 | # bootstrap.sh |
| 4 | |
| 5 | # Installs Salt and configure minimal SaltMaster or Minion to be used with: |
| 6 | # - http://github.com/salt-formulas-scripts |
| 7 | # - http://github.com/salt-formulas/salt-formula-salt (salt.master sls) |
| 8 | |
| 9 | # TODO: |
| 10 | # - use PPA repository as formula source |
| 11 | # - support for spm/yum |
| 12 | |
| 13 | |
| 14 | # Source specific env vars. |
| 15 | # shopt -u dotglob |
| 16 | export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass} |
| 17 | function source_local_envs() { |
Petr Michalec | b444ef9 | 2017-08-17 13:53:14 +0200 | [diff] [blame] | 18 | for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do |
Vasyl Saienko | 7a4161c | 2017-08-14 17:43:15 +0300 | [diff] [blame] | 19 | for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do |
| 20 | echo "Sourcing env variables from $f" |
| 21 | source $f |
| 22 | done |
| 23 | done |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 24 | } |
| 25 | source_local_envs |
| 26 | |
| 27 | ########################################## |
| 28 | # Set defaults env variables |
| 29 | |
| 30 | if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then |
| 31 | set -x |
| 32 | SALT_LOG_LEVEL="--state-verbose=true -ldebug" |
| 33 | fi |
| 34 | |
| 35 | export MAGENTA='\033[0;95m' |
| 36 | export YELLOW='\033[1;33m' |
| 37 | export BLUE='\033[0;35m' |
| 38 | export CYAN='\033[0;96m' |
| 39 | export RED='\033[0;31m' |
| 40 | export NC='\033[0m' # No Color' |
| 41 | |
| 42 | export LC_ALL=C |
| 43 | export SALT_LOG_LEVEL="--state-verbose=false -lerror" |
| 44 | export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }" |
| 45 | export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 46 | |
| 47 | |
| 48 | # salt apt repository |
| 49 | test -e /etc/lsb-release && eval $(cat /etc/lsb-release) |
| 50 | which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)} |
| 51 | # |
Dmitry Ukov | 95492a0 | 2017-10-23 11:34:45 +0400 | [diff] [blame] | 52 | export APT_REPOSITORY=${APT_REPOSITORY:- deb [arch=amd64] http://apt.mirantis.com/${DISTRIB_CODENAME} ${DISTRIB_REVISION:-stable} salt} |
chnyda | 30c07a6 | 2017-09-20 14:28:02 +0200 | [diff] [blame] | 53 | export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://apt.mirantis.com/public.gpg} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 54 | |
| 55 | # reclass |
| 56 | export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git |
| 57 | |
| 58 | # formula |
| 59 | export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas} |
| 60 | export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas} |
| 61 | export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master} |
| 62 | export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git |
| 63 | # essential set of formulas (known to by used on cfg01 node for most setups) |
Petr Ruzicka | 5ae6426 | 2017-10-13 14:29:52 +0200 | [diff] [blame] | 64 | FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS maas memcached openssh ntp nginx collectd sensu heka sphinx mysql grafana libvirt rsyslog glusterfs postfix xtrabackup freeipa prometheus telegraf elasticsearch kibana rundeck devops-portal rsync docker keepalived aptly jenkins gerrit artifactory influxdb horizon} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 65 | # minimal set of formulas for salt-master bootstrap |
| 66 | declare -a FORMULAS_SALT_MASTER=(linux reclass salt git $(echo $FORMULAS_SALT_MASTER)) |
| 67 | export FORMULAS_SALT_MASTER |
| 68 | |
| 69 | # system / host |
Petr Michalec | c749e86 | 2017-09-06 21:10:10 +0200 | [diff] [blame] | 70 | export HOSTNAME=${HOSTNAME:-`hostname -s`} |
| 71 | export HOSTNAME=${HOSTNAME//.*/} |
| 72 | export DOMAIN=${DOMAIN:-`hostname -d`} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 73 | export DOMAIN=${DOMAIN:-bootstrap.local} |
| 74 | |
| 75 | # salt |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 76 | export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}} |
Petr Michalec | 2e3a499 | 2017-08-17 14:20:43 +0200 | [diff] [blame] | 77 | export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 78 | |
| 79 | # saltstack |
Petr Michalec | 33c0489 | 2017-09-08 15:10:30 +0200 | [diff] [blame] | 80 | BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True} |
Petr Michalec | e11cf61 | 2017-09-08 18:21:48 +0200 | [diff] [blame] | 81 | BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION:- stable 2016.3 } |
Petr Michalec | 33c0489 | 2017-09-08 15:10:30 +0200 | [diff] [blame] | 82 | BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX $BOOTSTRAP_SALTSTACK_VERSION } |
Petr Michalec | e11cf61 | 2017-09-08 18:21:48 +0200 | [diff] [blame] | 83 | SALT_SOURCE=${SALT_SOURCE:-pkg} |
| 84 | # the version below is used salt pillar data |
| 85 | SALT_VERSION=${SALT_VERSION:-latest} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 86 | |
| 87 | # environment |
| 88 | if [ "$FORMULAS_SOURCE" == "git" ]; then |
| 89 | SALT_ENV=${SALT_ENV:-dev} |
| 90 | elif [ "$FORMULAS_SOURCE" == "pkg" ]; then |
| 91 | SALT_ENV=${SALT_ENV:-prd} |
| 92 | fi |
Petr Michalec | 05b5245 | 2017-09-08 14:26:59 +0200 | [diff] [blame] | 93 | eval "$(grep -h '=' /etc/*release 2> /dev/null)" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 94 | PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z) |
| 95 | case $PLATFORM_FAMILY in |
| 96 | debian ) |
| 97 | PKGTOOL="$SUDO apt-get" |
| 98 | test ${VERSION_ID//\.*/} -ge 16 && { |
| 99 | SVCTOOL=service |
| 100 | } || { SVCTOOL=service |
| 101 | } |
| 102 | ;; |
| 103 | rhel ) |
| 104 | PKGTOOL="$SUDO yum" |
| 105 | test ${VERSION_ID//\.*/} -ge 7 && { |
| 106 | SVCTOOL=systemctl |
| 107 | } || { SVCTOOL=service |
| 108 | } |
| 109 | ;; |
| 110 | esac |
| 111 | |
| 112 | export PLATFORM_FAMILY |
| 113 | export PKGTOOL |
| 114 | export SVCTOOL |
| 115 | |
| 116 | ########################################## |
| 117 | # FUNCTIONS |
| 118 | |
| 119 | log_info() { |
| 120 | echo -e "${YELLOW}[INFO] $* ${NC}" |
| 121 | } |
| 122 | |
| 123 | log_warn() { |
| 124 | echo -e "${MAGENTA}[WARN] $* ${NC}" |
| 125 | } |
| 126 | |
Petr Michalec | 24b30e8 | 2017-08-21 10:59:18 +0200 | [diff] [blame] | 127 | log_debug() { |
| 128 | echo -e "${CYAN}[WARN] $* ${NC}" |
| 129 | } |
| 130 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 131 | log_err() { |
| 132 | echo -e "${RED}[ERROR] $* ${NC}" >&2 |
| 133 | } |
| 134 | |
| 135 | configure_pkg_repo() |
| 136 | { |
| 137 | |
| 138 | case $PLATFORM_FAMILY in |
| 139 | debian) |
| 140 | if [ -n "$APT_REPOSITORY_PPA" ]; then |
| 141 | which add-apt-repository || $SUDO apt-get install -y software-properties-common |
| 142 | $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA} |
| 143 | else |
Mykyta Karpin | fbcb548 | 2017-10-04 14:15:25 +0300 | [diff] [blame] | 144 | echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/mcp_salt.list >/dev/null |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 145 | curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add - |
| 146 | fi |
| 147 | $SUDO apt-get clean |
| 148 | $SUDO apt-get update |
| 149 | ;; |
| 150 | rhel) |
| 151 | $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm |
| 152 | $SUDO yum clean all |
| 153 | ;; |
| 154 | esac |
| 155 | |
| 156 | } |
| 157 | |
| 158 | _atexit() { |
| 159 | RETVAL=$? |
| 160 | trap true INT TERM EXIT |
| 161 | |
| 162 | if [ $RETVAL -ne 0 ]; then |
| 163 | log_err "Execution failed" |
| 164 | else |
| 165 | log_info "Execution successful" |
| 166 | fi |
| 167 | return $RETVAL |
| 168 | } |
| 169 | |
| 170 | retry() { |
| 171 | local tries |
| 172 | if [[ $1 =~ ^[0-9]+$ ]]; then |
| 173 | tries=$1; shift |
| 174 | else |
| 175 | tries=3 |
| 176 | fi |
Petr Michalec | 262e3ad | 2017-10-06 13:41:58 +0200 | [diff] [blame] | 177 | ret=1 |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 178 | for i in $(seq 1 $tries); do |
Petr Michalec | 262e3ad | 2017-10-06 13:41:58 +0200 | [diff] [blame] | 179 | "$@" && return $? || ret=$? |
| 180 | sleep $i |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 181 | done |
Petr Michalec | 9fec8b3 | 2017-10-05 14:46:42 +0200 | [diff] [blame] | 182 | return $ret |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 183 | } |
| 184 | |
| 185 | function clone_reclass() { |
Petr Michalec | a361d4e | 2017-09-08 11:38:16 +0200 | [diff] [blame] | 186 | if [ ! -d ${RECLASS_ROOT}/classes ]; then |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 187 | # No reclass at all, clone from given address |
| 188 | ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true |
| 189 | if echo ${RECLASS_BRANCH:-master} | egrep -q "^refs"; then |
| 190 | git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT} |
| 191 | cd ${RECLASS_ROOT} |
| 192 | git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH:-master} && git checkout FETCH_HEAD |
| 193 | cd - |
| 194 | else |
| 195 | git clone -b ${RECLASS_BRANCH:-master} ${RECLASS_ADDRESS} ${RECLASS_ROOT}; |
| 196 | fi; |
| 197 | fi; |
Petr Michalec | 679f15b | 2017-09-18 16:16:29 +0200 | [diff] [blame] | 198 | if [ ! -d ${RECLASS_ROOT}/classes ]; then |
Petr Michalec | a361d4e | 2017-09-08 11:38:16 +0200 | [diff] [blame] | 199 | log_err "Reclass ${RECLASS_ROOT} is not fetched locally;" |
| 200 | ls -Rla ${RECLASS_ROOT} |
| 201 | exit 1 |
| 202 | fi; |
| 203 | $SUDO mkdir -p $RECLASS_ROOT/classes/service |
| 204 | $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 205 | } |
| 206 | |
| 207 | |
| 208 | ########################################## |
| 209 | # Main calls |
| 210 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 211 | system_config_ssh_conf() { |
| 212 | for conf in ~/.ssh/config /root/.ssh/config; do |
| 213 | $SUDO mkdir -p $(dirname $conf) |
| 214 | if ! grep StrictHostKeyChecking $conf; then |
| 215 | # this should be used only in CI environment |
| 216 | echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee $conf >/dev/null |
| 217 | fi |
| 218 | done |
| 219 | if ! grep github.com ~/.ssh/known_hosts; then |
| 220 | ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true |
| 221 | fi |
| 222 | } |
| 223 | |
| 224 | system_config_salt_modules_prereq() { |
| 225 | # salt-formulas custom modules dependencies, etc: |
| 226 | $SUDO $PKGTOOL install -y iproute2 curl sudo apt-transport-https python-psutil python-apt python-m2crypto python-oauth python-pip &>/dev/null |
| 227 | } |
| 228 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 229 | system_config_minion() { |
| 230 | log_info "System configuration salt minion" |
| 231 | } |
| 232 | |
| 233 | system_config_master() { |
| 234 | log_info "System configuration salt master" |
| 235 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 236 | system_config_salt_modules_prereq |
| 237 | system_config_ssh_conf |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 238 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 239 | if ! grep '127.0.1.2.*salt' /etc/hosts; then |
| 240 | echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null |
| 241 | fi |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 242 | |
| 243 | which reclass || $SUDO $PKGTOOL install -y reclass |
| 244 | |
| 245 | which reclass-salt || { |
| 246 | test -e /usr/share/reclass/reclass-salt && { |
| 247 | ln -fs /usr/share/reclass/reclass-salt /usr/bin |
| 248 | } |
| 249 | } |
| 250 | } |
| 251 | |
| 252 | configure_salt_master() |
| 253 | { |
| 254 | |
| 255 | echo "Configuring salt-master ..." |
| 256 | |
Petr Michalec | 4be5e5b | 2017-08-17 11:44:49 +0200 | [diff] [blame] | 257 | if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then |
Petr Michalec | 29d3ea3 | 2017-10-31 17:22:36 +0100 | [diff] [blame] | 258 | read -d '' IGNORE_CLASS_NOTFOUND <<-EOF |
| 259 | ignore_class_notfound: True |
| 260 | ignore_class_regexp: |
| 261 | - 'service.*' |
| 262 | EOF |
Petr Michalec | 4be5e5b | 2017-08-17 11:44:49 +0200 | [diff] [blame] | 263 | fi |
| 264 | |
Petr Michalec | dd1a047 | 2017-09-06 19:27:24 +0200 | [diff] [blame] | 265 | # to force alternative reclass module path |
Petr Michalec | d9d0a32 | 2017-09-06 19:38:32 +0200 | [diff] [blame] | 266 | if [ -n "$RECLASS_SOURCE_PATH" ]; then |
| 267 | RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}" |
| 268 | else |
| 269 | RECLASS_SOURCE_PATH="" |
| 270 | fi |
Petr Michalec | dd1a047 | 2017-09-06 19:27:24 +0200 | [diff] [blame] | 271 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 272 | [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d |
| 273 | cat <<-EOF > /etc/salt/master.d/master.conf |
| 274 | file_roots: |
| 275 | base: |
| 276 | - /usr/share/salt-formulas/env |
| 277 | prd: |
| 278 | - /srv/salt/env/prd |
| 279 | dev: |
| 280 | - /srv/salt/env/dev |
| 281 | pillar_opts: False |
| 282 | open_mode: True |
| 283 | reclass: &reclass |
| 284 | storage_type: yaml_fs |
| 285 | inventory_base_uri: ${RECLASS_ROOT} |
Petr Michalec | 4be5e5b | 2017-08-17 11:44:49 +0200 | [diff] [blame] | 286 | ${IGNORE_CLASS_NOTFOUND} |
Petr Michalec | dd1a047 | 2017-09-06 19:27:24 +0200 | [diff] [blame] | 287 | ${RECLASS_SOURCE_PATH} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 288 | ext_pillar: |
| 289 | - reclass: *reclass |
| 290 | master_tops: |
| 291 | reclass: *reclass |
| 292 | EOF |
| 293 | |
| 294 | echo "Configuring reclass ..." |
| 295 | |
| 296 | [ ! -d /etc/reclass ] && mkdir /etc/reclass |
| 297 | cat <<-EOF > /etc/reclass/reclass-config.yml |
| 298 | storage_type: yaml_fs |
| 299 | pretty_print: True |
| 300 | output: yaml |
| 301 | inventory_base_uri: ${RECLASS_ROOT} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 302 | EOF |
| 303 | |
| 304 | clone_reclass |
| 305 | # override some envs from cluster level *.env, use with care |
| 306 | source_local_envs |
| 307 | |
| 308 | cd ${RECLASS_ROOT} |
| 309 | if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then |
| 310 | # Possibly subrepo checkout needed |
| 311 | git submodule update --init --recursive |
| 312 | fi |
| 313 | |
Petr Michalec | 212cc6a | 2017-08-17 21:39:40 +0200 | [diff] [blame] | 314 | mkdir -vp ${RECLASS_ROOT}/nodes/_generated |
Petr Michalec | 51ece84 | 2017-09-06 20:44:15 +0200 | [diff] [blame] | 315 | rm -rvf ${RECLASS_ROOT}/nodes/_generated/* |
| 316 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 317 | CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1) |
Petr Michalec | 212cc6a | 2017-08-17 21:39:40 +0200 | [diff] [blame] | 318 | CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 319 | if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then |
Petr Michalec | 24b30e8 | 2017-08-21 10:59:18 +0200 | [diff] [blame] | 320 | log_warn "Salt Master node specification has not been found in model." |
| 321 | log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 322 | cat <<-EOF > ${CONFIG} |
| 323 | classes: |
Petr Michalec | d81d1f5 | 2017-08-17 20:18:06 +0200 | [diff] [blame] | 324 | - cluster.${CLUSTER_NAME}.infra.config |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 325 | parameters: |
| 326 | _param: |
Petr Michalec | a7de6df | 2017-08-31 12:16:57 +0200 | [diff] [blame] | 327 | salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 328 | salt_master_base_environment: $SALT_ENV |
Petr Michalec | d81d1f5 | 2017-08-17 20:18:06 +0200 | [diff] [blame] | 329 | salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master} |
| 330 | reclass_data_revision: ${RECLASS_BRANCH:-master} |
| 331 | reclass_data_repository: "$RECLASS_ADDRESS" |
Petr Michalec | a7de6df | 2017-08-31 12:16:57 +0200 | [diff] [blame] | 332 | reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME} |
Petr Michalec | d81d1f5 | 2017-08-17 20:18:06 +0200 | [diff] [blame] | 333 | linux_system_codename: ${DISTRIB_CODENAME} |
| 334 | cluster_name: ${CLUSTER_NAME} |
| 335 | cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 336 | linux: |
| 337 | system: |
Petr Michalec | d81d1f5 | 2017-08-17 20:18:06 +0200 | [diff] [blame] | 338 | name: ${HOSTNAME:-cfg01} |
| 339 | domain: ${DOMAIN:-$CLUSTER_NAME.local} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 340 | # ######## |
| 341 | EOF |
| 342 | |
| 343 | if [ "$SALT_VERSION" == "latest" ]; then |
| 344 | VERSION="" |
| 345 | else |
| 346 | VERSION="version: $SALT_VERSION" |
| 347 | fi |
| 348 | |
| 349 | cat <<-EOF >> ${CONFIG} |
| 350 | salt: |
| 351 | master: |
| 352 | accept_policy: open_mode |
| 353 | source: |
| 354 | engine: $SALT_SOURCE |
| 355 | $VERSION |
| 356 | minion: |
| 357 | source: |
| 358 | engine: $SALT_SOURCE |
| 359 | $VERSION |
| 360 | # ######## |
| 361 | # vim: ft=yaml sw=2 ts=2 sts=2 |
| 362 | EOF |
| 363 | fi |
Petr Michalec | 24b30e8 | 2017-08-21 10:59:18 +0200 | [diff] [blame] | 364 | |
| 365 | log_debug "Salt Master node config yaml:" |
| 366 | log_debug "$(cat ${CONFIG})" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 367 | } |
| 368 | |
| 369 | configure_salt_minion() |
| 370 | { |
| 371 | [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d |
| 372 | cat <<-EOF > /etc/salt/minion.d/minion.conf |
Petr Michalec | a7de6df | 2017-08-31 12:16:57 +0200 | [diff] [blame] | 373 | master: ${MASTER_IP:-$MASTER_HOSTNAME} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 374 | id: $MINION_ID |
| 375 | EOF |
| 376 | } |
| 377 | |
Petr Michalec | a6cd2bd | 2017-09-07 16:59:19 +0200 | [diff] [blame] | 378 | install_reclass() |
| 379 | { |
| 380 | VERSION=${1:-$RECLASS_VERSION} |
| 381 | VERSION=${VERSION:-master} |
| 382 | # tries to replace all local version system version |
| 383 | for s in $(python -c "import site; print(' '.join(site.getsitepackages()))"); do |
Petr Michalec | a2f351c | 2017-09-07 17:37:44 +0200 | [diff] [blame] | 384 | sudo -H pip install --upgrade --force-reinstall -I \ |
Petr Michalec | a6cd2bd | 2017-09-07 16:59:19 +0200 | [diff] [blame] | 385 | -t "$s" git+https://github.com/salt-formulas/reclass.git@${VERSION}; |
| 386 | done |
| 387 | } |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 388 | |
| 389 | install_salt_master_pkg() |
| 390 | { |
| 391 | echo -e "\nPreparing base OS repository ...\n" |
| 392 | |
| 393 | configure_pkg_repo |
| 394 | |
| 395 | echo -e "\nInstalling salt master ...\n" |
| 396 | |
| 397 | case $PLATFORM_FAMILY in |
| 398 | debian) |
| 399 | $SUDO apt-get install -y git |
| 400 | which reclass || $SUDO apt install -qqq -y reclass |
| 401 | curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true |
| 402 | ;; |
| 403 | rhel) |
| 404 | yum install -y git |
| 405 | which reclass || $SUDO yum install -y reclass |
| 406 | curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true |
| 407 | ;; |
| 408 | esac |
| 409 | |
| 410 | which reclass-salt || { |
| 411 | test -e /usr/share/reclass/reclass-salt && { |
| 412 | ln -fs /usr/share/reclass/reclass-salt /usr/bin |
| 413 | } |
| 414 | } |
| 415 | |
| 416 | configure_salt_master |
| 417 | |
| 418 | echo -e "\nRestarting services ...\n" |
| 419 | [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub |
| 420 | $SVCTOOL salt-master restart |
| 421 | } |
| 422 | |
| 423 | install_salt_master_pip() |
| 424 | { |
| 425 | echo -e "\nPreparing base OS repository ...\n" |
| 426 | |
| 427 | case $PLATFORM_FAMILY in |
| 428 | debian) |
| 429 | $SUDO apt-get install -y python-pip python-dev zlib1g-dev git |
| 430 | which reclass || $SUDO apt-get install -y reclass |
| 431 | ;; |
| 432 | rhel) |
| 433 | $SUDO yum install -y git |
| 434 | which reclass || $SUDO yum install -y reclass |
| 435 | ;; |
| 436 | esac |
| 437 | |
| 438 | echo -e "\nInstalling salt master ...\n" |
| 439 | # TODO: replace with saltstack bootstrap script |
| 440 | |
| 441 | if [ "$SALT_VERSION" == "latest" ]; then |
| 442 | pip install salt |
| 443 | else |
| 444 | pip install salt==$SALT_VERSION |
| 445 | fi |
| 446 | |
| 447 | curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master |
| 448 | ln -s /usr/local/bin/salt-master /usr/bin/salt-master |
| 449 | |
| 450 | which reclass-salt || { |
| 451 | test -e /usr/share/reclass/reclass-salt && { |
| 452 | ln -fs /usr/share/reclass/reclass-salt /usr/bin |
| 453 | } |
| 454 | } |
| 455 | |
| 456 | configure_salt_master |
| 457 | |
| 458 | echo -e "\nRestarting services ...\n" |
| 459 | [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub |
| 460 | $SVCTOOL salt-master restart |
| 461 | } |
| 462 | |
| 463 | |
| 464 | |
| 465 | install_salt_minion_pkg() |
| 466 | { |
| 467 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 468 | echo -e "\nInstalling salt minion ...\n" |
| 469 | |
| 470 | case $PLATFORM_FAMILY in |
| 471 | debian) |
| 472 | curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true |
| 473 | ;; |
| 474 | rhel) |
| 475 | curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true |
| 476 | ;; |
| 477 | esac |
| 478 | |
| 479 | |
| 480 | configure_salt_minion |
Petr Michalec | 3b7fdd8 | 2017-09-08 15:35:56 +0200 | [diff] [blame] | 481 | #$SVCTOOL salt-minion restart |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 482 | } |
| 483 | |
| 484 | install_salt_minion_pip() |
| 485 | { |
| 486 | echo -e "\nInstalling salt minion ...\n" |
| 487 | |
| 488 | curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion |
| 489 | ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion |
| 490 | |
| 491 | configure_salt_minion |
Petr Michalec | 3b7fdd8 | 2017-09-08 15:35:56 +0200 | [diff] [blame] | 492 | #$SVCTOOL salt-minion restart |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 493 | } |
| 494 | |
| 495 | |
| 496 | install_salt_formula_pkg() |
| 497 | { |
| 498 | configure_pkg_repo |
| 499 | |
| 500 | case $PLATFORM_FAMILY in |
| 501 | debian) |
| 502 | echo "Configuring necessary formulas ..." |
| 503 | |
| 504 | [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service |
| 505 | # Set essentials if FORMULAS_SALT_MASTER is not defined at all |
| 506 | [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached") |
| 507 | for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do |
| 508 | echo -e "\nConfiguring salt formula ${formula_service} ...\n" |
| 509 | [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \ |
| 510 | if ! $SUDO apt-get install -y salt-formula-${formula_service}; then |
| 511 | echo -e "\nInstall salt-formula-${formula_service} failed.\n" |
| 512 | exit 1 |
| 513 | fi |
| 514 | [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \ |
| 515 | ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service} |
| 516 | done |
| 517 | ;; |
| 518 | rhel) |
| 519 | # TODO |
| 520 | ;; |
| 521 | esac |
| 522 | |
| 523 | [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo "" |
| 524 | [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo "" |
| 525 | } |
| 526 | |
| 527 | install_salt_formula_git() |
| 528 | { |
| 529 | echo "Configuring necessary formulas ..." |
| 530 | |
| 531 | [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service |
| 532 | # Set essentials if FORMULAS_SALT_MASTER is not defined at all |
| 533 | [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached") |
| 534 | for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do |
| 535 | echo -e "\nConfiguring salt formula ${formula_service} ...\n" |
| 536 | _BRANCH=${FORMULAS_BRANCH} |
| 537 | [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && { |
| 538 | if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then |
| 539 | # Fallback to the master branch if the branch doesn't exist for this repository |
| 540 | _BRANCH=master |
| 541 | fi |
| 542 | if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then |
| 543 | echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n" |
| 544 | exit 1 |
| 545 | fi |
| 546 | } || { |
| 547 | cd ${FORMULAS_PATH}/env/_formulas/${formula_service}; |
| 548 | git fetch origin/${_BRANCH} || git fetch --all |
| 549 | git checkout ${_BRANCH} && git pull || git pull; |
| 550 | cd - |
| 551 | } |
| 552 | [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \ |
| 553 | ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service} |
| 554 | [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \ |
| 555 | ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service} |
| 556 | done |
| 557 | |
| 558 | [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo "" |
| 559 | [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo "" |
| 560 | } |
| 561 | |
| 562 | |
| 563 | saltmaster_bootstrap() { |
| 564 | |
| 565 | log_info "Salt master setup" |
| 566 | test -n "$MASTER_HOSTNAME" || exit 1 |
| 567 | |
| 568 | clone_reclass |
| 569 | # override some envs from cluster level *.env, use with care |
| 570 | source_local_envs |
| 571 | |
Petr Michalec | 7ed7d8f | 2017-10-10 15:38:29 +0200 | [diff] [blame] | 572 | pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {} || true |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 573 | pkill -9 salt-minion |
projoke | 3c30e7d | 2017-10-19 17:15:40 +0800 | [diff] [blame] | 574 | SCRIPTS=$(dirname $0) |
| 575 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 576 | test -e ${SCRIPTS}/.salt-master-setup.sh.passed || { |
Adam Tengler | 035f24f | 2017-09-11 19:29:31 +0200 | [diff] [blame] | 577 | export MASTER_IP=${MASTER_IP:-127.0.0.1} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 578 | export MINION_ID=${MASTER_HOSTNAME} |
| 579 | if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then |
| 580 | SALT_MASTER_SETUP_OUTPUT='/dev/stdout' |
| 581 | fi |
| 582 | # call local "setup() master" |
| 583 | #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then |
| 584 | if ! setup master; then |
| 585 | #cat /tmp/salt-master-setup.log |
| 586 | log_err "salt master setup() failed." |
| 587 | exit 1 |
| 588 | else |
| 589 | $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed |
| 590 | fi |
| 591 | } |
| 592 | |
Petr Michalec | a6cd2bd | 2017-09-07 16:59:19 +0200 | [diff] [blame] | 593 | if [[ $RECLASS_VERSION =~ ^(dev|devel|master)$ ]]; then |
Petr Michalec | 2f9a35b | 2017-09-07 17:08:06 +0200 | [diff] [blame] | 594 | log_warn "Install development version of reclass" |
Petr Michalec | 06d088b | 2017-10-31 17:37:09 +0100 | [diff] [blame] | 595 | install_reclass ${RECLASS_VERSION/dev*/develop} |
Petr Michalec | a6cd2bd | 2017-09-07 16:59:19 +0200 | [diff] [blame] | 596 | fi |
| 597 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 598 | log_info "Re/starting salt services" |
Petr Michalec | 7ed7d8f | 2017-10-10 15:38:29 +0200 | [diff] [blame] | 599 | $SUDO service salt-minion stop |
| 600 | $SUDO service salt-master stop |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 601 | sleep 10 |
Petr Michalec | 7ed7d8f | 2017-10-10 15:38:29 +0200 | [diff] [blame] | 602 | pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {} || true |
| 603 | pkill -9 salt-minion |
| 604 | $SUDO service salt-master start |
| 605 | $SUDO service salt-minion start |
| 606 | sleep 15 |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 607 | } |
| 608 | |
| 609 | # Init salt master |
| 610 | saltmaster_init() { |
| 611 | |
| 612 | log_info "Runing saltmaster states" |
| 613 | test -n "$MASTER_HOSTNAME" || exit 1 |
| 614 | |
| 615 | set -e |
| 616 | $SUDO salt-call saltutil.sync_all >/dev/null |
| 617 | |
| 618 | # TODO: Placeholder update saltmaster spec (nodes/FQDN.yml) to be able to bootstrap with minimal configuration |
| 619 | # (ie: with linux, git, salt formulas) |
| 620 | |
| 621 | #log_info "Verify SaltMaster, before salt-master is fully initialized" |
| 622 | #if ! $SUDO reclass-salt -p ${MASTER_HOSTNAME} &> /tmp/${MASTER_HOSTNAME}.pillar;then |
| 623 | # log_warn "Node verification before initialization failed."; cat /tmp/${MASTER_HOSTNAME}.pillar; |
| 624 | #fi |
| 625 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 626 | # workarond isolated and not fully bootstraped environments |
Petr Michalec | 2801acb | 2017-10-31 15:00:15 +0100 | [diff] [blame] | 627 | if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then |
Petr Michalec | 64adbd7 | 2017-10-31 15:26:41 +0100 | [diff] [blame] | 628 | SALT_MASTER_PILLAR='"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": "'${RECLASS_IGNORE_CLASS_NOTFOUND:-False}'", "ignore_class_regexp": ["service.*"]}}}},' |
Petr Michalec | 2801acb | 2017-10-31 15:00:15 +0100 | [diff] [blame] | 629 | fi |
Petr Michalec | 64adbd7 | 2017-10-31 15:26:41 +0100 | [diff] [blame] | 630 | PILLAR='{'${SALT_MASTER_PILLAR}' "reclass":{"storage":{"data_source":{"engine":"local"}}} }' |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 631 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 632 | log_info "State: salt.master.env" |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 633 | if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 634 | log_err "State salt.master.env failed, keep your eyes wide open." |
| 635 | fi |
| 636 | |
| 637 | log_info "State: salt.master.pillar" |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 638 | retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 639 | # Note: sikp reclass data dir states |
| 640 | # in order to avoid pull from configured repo/branch |
| 641 | |
| 642 | # Revert temporary SaltMaster minimal configuration, if any |
| 643 | pushd $RECLASS_ROOT |
| 644 | if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then |
Petr Michalec | 87778fc | 2017-11-02 10:13:25 +0100 | [diff] [blame^] | 645 | PILLAR='{"reclass":{"storage":{"data_source":{"engine":"local"}}} }' |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 646 | git status || true |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 647 | log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 648 | log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*." |
| 649 | git checkout -- $RECLASS_ROOT/nodes || true |
| 650 | log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state." |
| 651 | log_info "State: salt.master.env" |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 652 | if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 653 | log_err "State salt.master.env failed, keep your eyes wide open." |
| 654 | fi |
| 655 | log_info "State: salt.master.pillar" |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 656 | retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 657 | fi |
| 658 | popd |
| 659 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 660 | # finally re-configure salt master conf, ie: may remove ignore_class_notfound option |
| 661 | log_info "State: salt.master.service" |
Petr Michalec | 9fec8b3 | 2017-10-05 14:46:42 +0200 | [diff] [blame] | 662 | retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 663 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 664 | log_info "State: salt.master.storage.node" |
| 665 | set +e |
Petr Michalec | a514134 | 2017-08-16 12:55:20 +0200 | [diff] [blame] | 666 | # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT. |
Petr Michalec | 9fec8b3 | 2017-10-05 14:46:42 +0200 | [diff] [blame] | 667 | retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 668 | ret=$? |
| 669 | set -e |
| 670 | |
| 671 | if [[ $ret -eq 2 ]]; then |
| 672 | log_err "State reclass.storage.node failed with exit code 2 but continuing." |
| 673 | elif [[ $ret -ne 0 ]]; then |
| 674 | log_err "State reclass.storage.node failed with exit code $ret" |
| 675 | exit 1 |
| 676 | fi |
| 677 | |
| 678 | log_info "Re/starting salt services" |
| 679 | $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf |
Petr Michalec | c0bfa97 | 2017-09-08 15:21:01 +0200 | [diff] [blame] | 680 | $SUDO service salt-minion stop |
| 681 | $SUDO service salt-master stop |
Petr Michalec | 7ed7d8f | 2017-10-10 15:38:29 +0200 | [diff] [blame] | 682 | sleep 10 |
| 683 | pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {} || true |
Petr Michalec | c0bfa97 | 2017-09-08 15:21:01 +0200 | [diff] [blame] | 684 | $SUDO service salt-master start |
| 685 | $SUDO service salt-minion start |
Petr Michalec | 7ed7d8f | 2017-10-10 15:38:29 +0200 | [diff] [blame] | 686 | sleep 15 |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 687 | $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null |
| 688 | |
| 689 | verify_salt_master |
| 690 | set +e |
| 691 | |
| 692 | } |
| 693 | |
| 694 | |
| 695 | function verify_salt_master() { |
| 696 | set -e |
| 697 | |
| 698 | log_info "Verify Salt master" |
| 699 | test -n "$MASTER_HOSTNAME" || exit 1 |
| 700 | |
| 701 | if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then |
Petr Michalec | a514134 | 2017-08-16 12:55:20 +0200 | [diff] [blame] | 702 | $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml |
| 703 | $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 704 | $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles |
| 705 | $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state |
| 706 | $SUDO salt-call --no-color grains.items |
| 707 | $SUDO salt-call --no-color pillar.data |
| 708 | fi |
Petr Michalec | a514134 | 2017-08-16 12:55:20 +0200 | [diff] [blame] | 709 | # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_* |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 710 | if ! $SUDO reclass --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then |
| 711 | log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo" |
| 712 | exit 1 |
| 713 | fi |
| 714 | } |
| 715 | |
| 716 | function verify_salt_minion() { |
| 717 | set -e |
| 718 | node=$1 |
| 719 | log_info "Verifying ${node}" |
| 720 | if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then |
| 721 | $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles |
| 722 | $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate |
| 723 | fi |
| 724 | if ! $SUDO reclass --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then |
| 725 | log_err "For more details see full log /tmp/${node}.reclass.nodeinfo" |
| 726 | if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then |
| 727 | exit 1 |
| 728 | fi |
| 729 | fi |
| 730 | } |
| 731 | |
| 732 | function verify_salt_minions() { |
| 733 | #set -e |
Petr Michalec | 679f15b | 2017-09-18 16:16:29 +0200 | [diff] [blame] | 734 | NODES=$(find $RECLASS_ROOT/nodes/_generated/ -name "*.yml" | grep -v "cfg") |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 735 | log_info "Verifying minions: $(echo ${NODES}|xargs)" |
| 736 | |
| 737 | # Parallel |
| 738 | #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify" |
| 739 | #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30 |
| 740 | |
| 741 | function filterFails() { |
| 742 | grep -v '/grains' | tee -a $1 | tail -n20 |
| 743 | } |
| 744 | |
| 745 | log_info "Verify nodes" |
| 746 | passed=0 |
| 747 | for node in ${NODES}; do |
| 748 | node=$(basename $node .yml) |
| 749 | |
| 750 | # filter first in cluster.. ctl-01, mon-01, etc.. |
| 751 | if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then |
| 752 | verify_salt_minion ${node} || continue |
| 753 | else |
| 754 | echo Skipped $node. |
| 755 | fi |
| 756 | passed=$(($passed+1)) |
| 757 | done |
| 758 | # fail on failures |
| 759 | total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l) |
| 760 | test ! $passed -lt $total || log_err "Results: $passed of $total passed." |
| 761 | test ! $passed -lt $total || { |
| 762 | tail -n50 /tmp/*.pillar_verify |
| 763 | return 1 |
| 764 | } |
| 765 | } |
| 766 | |
| 767 | |
| 768 | |
| 769 | ########################################## |
| 770 | # To install salt master/minon |
| 771 | |
| 772 | function install() { |
| 773 | setup $@ |
| 774 | } |
| 775 | |
| 776 | function setup() { |
| 777 | # CLI |
| 778 | while [ x"$1" != x"" ]; do |
| 779 | which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null |
| 780 | |
| 781 | case $1 in |
| 782 | master ) |
| 783 | install_salt_master_$SALT_SOURCE |
| 784 | install_salt_minion_$SALT_SOURCE |
| 785 | install_salt_formula_$FORMULAS_SOURCE |
| 786 | ;; |
| 787 | minion ) |
| 788 | install_salt_minion_$SALT_SOURCE |
| 789 | ;; |
| 790 | esac |
| 791 | shift |
| 792 | done |
| 793 | echo DONE |
| 794 | } |
| 795 | |
| 796 | function bootstrap() { |
| 797 | log_info "Bootstrap & verification of SaltMaster and configured minions." |
| 798 | trap _atexit INT TERM EXIT |
| 799 | |
| 800 | system_config_master |
| 801 | saltmaster_bootstrap &&\ |
Petr Michalec | 58575b9 | 2017-08-20 10:42:25 +0200 | [diff] [blame] | 802 | saltmaster_init #&&\ |
Petr Michalec | a514134 | 2017-08-16 12:55:20 +0200 | [diff] [blame] | 803 | #verify_salt_minions |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 804 | } |
| 805 | |
| 806 | function default() { |
| 807 | bootstrap $@ |
| 808 | } |
| 809 | |
| 810 | |
| 811 | ########################################## |
| 812 | [[ "$0" != "$BASH_SOURCE" ]] || { |
| 813 | # unless file is being sourced |
| 814 | default $@ |
| 815 | } |